unit main;

interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, StdCtrls, ComCtrls, ExtCtrls,
	DirectShow9;

type
	TForm1 = class(TForm)
		OpenDialog1: TOpenDialog;
    Button_Open: TButton;
		Button_Play: TButton;
    Button_Pause: TButton;
    Button_Stop: TButton;
		TrackBar1: TTrackBar;
    Label_Time: TLabel;
    Label_VideoSize: TLabel;
		Timer1: TTimer;
		procedure FormDestroy(Sender: TObject);
		procedure Button_OpenClick (Sender: TObject);
		procedure Button_PlayClick (Sender: TObject);
    procedure Button_PauseClick(Sender: TObject);
		procedure Button_StopClick (Sender: TObject);
		procedure TrackBar1Change(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
	private
		{ Private 錾 }
		F_GraphBuilder  : IGraphBuilder;
		F_MediaPosition : IMediaPosition;
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation
uses
	ActiveX,
	CommCtrl;

{$R *.dfm}


procedure TForm1.FormDestroy(Sender: TObject);
begin
	F_GraphBuilder  := nil;
	F_MediaPosition := nil;
end;

procedure TForm1.Button_OpenClick(Sender: TObject);
var
	li_Ret : HResult;
	lf_Len : TRefTime;
	l_BasicVideo : IBasicVideo;
	li_Width  : Integer;
	li_Height : Integer;
begin
	if (OpenDialog1.Execute) then begin
		F_MediaPosition := nil;
		F_GraphBuilder  := nil;

		//Ot쐬
		li_Ret := CoCreateInstance(
				CLSID_FilterGraph,
				nil,
				CLSCTX_INPROC_SERVER,
				IID_IGraphBuilder,
				F_GraphBuilder
		);
		if (li_Ret <> S_OK) then begin
			Exit;
		end;

		//ǂݍ
		if not(Succeeded(F_GraphBuilder.RenderFile(POLESTR(WideString(OpenDialog1.FileName)), nil))) then begin
			Exit;
		end;

		//^Cgo[Ƀt@C\
		Caption := ExtractFileName(OpenDialog1.FileName);

		//rfĨTCY擾
		F_GraphBuilder.QueryInterface(IBasicVideo, l_BasicVideo);
		//li_Widthli_Height͕̏K{B
		li_Width  := 0;
		li_Height := 0;
		l_BasicVideo.get_VideoWidth (li_Width);
		l_BasicVideo.get_VideoHeight(li_Height);
		l_BasicVideo := nil;
		if (li_Width > 0) and (li_Height > 0) then begin
			Label_VideoSize.Caption := Format('%d~%d', [li_Width, li_Height]);
		end else begin
			Label_VideoSize.Caption := '';
		end;

		//擾
		F_GraphBuilder.QueryInterface(IMediaPosition, F_MediaPosition);
		F_MediaPosition.get_Duration(lf_Len);
		TrackBar1.Max := Trunc(lf_Len);

		//ĐJn
		Button_PlayClick(nil);
	end;
end;

procedure TForm1.Button_PlayClick(Sender: TObject);
//ĐJn
var
	l_MediaControl : IMediaControl;
begin
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Run;
		l_MediaControl := nil;
		Timer1.Enabled := True;
	end;
end;

procedure TForm1.Button_PauseClick(Sender: TObject);
//ꎞ~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Pause;
		l_MediaControl := nil;
	end;
end;

procedure TForm1.Button_StopClick(Sender: TObject);
//~
var
	l_MediaControl : IMediaControl;
begin
	Timer1.Enabled := False;
	if (Assigned(F_GraphBuilder)) then begin
		F_GraphBuilder.QueryInterface(IMediaControl, l_MediaControl);
		l_MediaControl.Stop;

		//~łPauseƕςȂ
		//擪ɖ߂ɂIMediaPositiong
		F_MediaPosition.put_CurrentPosition(0);

		//ړł݈͌ʒũt[`悳ȂB
		//݈ʒũt[`悳邽߂PauseĂԁB
//		l_MediaControl.Pause;
		l_MediaControl.StopWhenReady;
		l_MediaControl := nil;

		TrackBar1.Position := 0;
	end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
//݈ʒu\
	function FloatToTime(fTime : TRefTime) : String;
	var
		li_Time, li_Hour, li_Min, li_Sec : Integer;
	begin
		li_Time := Trunc(fTime);
		li_Hour := li_Time div 60 div 60;
		li_Min  := li_Time div 60 mod 60;
		li_Sec  := li_Time mod 60;
		Result  := Format('%d:%.2d:%.2d', [li_Hour, li_Min, li_Sec]);
	end;
	function IsDragThumb: Boolean;
	//gbNo[̃XC_[GĂ邩B
	//ۂ̓gbNo[}EXLv`Ă邩B
	begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			Result := False;
			Exit;
		end;
		Result := (GetCapture = TrackBar1.Handle);
	end;
var
	lf_Len : TRefTime;
	lf_Pos : TRefTime;
begin
	if (Assigned(F_GraphBuilder)) then begin
		Timer1.Tag := 1;
		F_MediaPosition.get_Duration(lf_Len);
		F_MediaPosition.get_CurrentPosition(lf_Pos);

		Label_Time.Caption := Format('%s/%s', [FloatToTime(lf_Pos), FloatToTime(lf_Len)]);

		if not(IsDragThumb) then begin
			//gbNo[̃XC_[GĂȂXC_[݈ʒuɈړB
			TrackBar1.Position := Trunc(lf_Pos);
		end;
		Timer1.Tag := 0;
	end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
//gbNo[ړ
begin
	if (Timer1.Tag <> 0) then begin
		Exit;
	end;

	if (Assigned(F_GraphBuilder)) then begin
		if not(BOOL(Hi(GetAsyncKeyState(VK_LBUTTON)))) then begin
			F_MediaPosition.put_CurrentPosition(TrackBar1.Position);
		end;
	end;
end;

end.
